'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rcTooltip = require('rc-tooltip');

var _rcTooltip2 = _interopRequireDefault(_rcTooltip);

var _placements = require('rc-tooltip/lib/placements');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import * as RcTooltip from 'antd';


var Tooltip = function (_React$Component) {
  _inherits(Tooltip, _React$Component);

  function Tooltip(props) {
    _classCallCheck(this, Tooltip);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.getPlacements = function () {
      var _this$props = _this.props,
          builtinPlacements = _this$props.builtinPlacements,
          arrowPointAtCenter = _this$props.arrowPointAtCenter;

      var arrowWidth = 5,
          horizontalArrowShift = 12,
          verticalArrowShift = 8;
      var placements = _placements.placements;
      if (arrowPointAtCenter) {
        placements = {
          left: {
            points: ['cr', 'cl'],
            offset: [-4, 0]
          },
          right: {
            points: ['cl', 'cr'],
            offset: [4, 0]
          },
          top: {
            points: ['bc', 'tc'],
            offset: [0, -4]
          },
          bottom: {
            points: ['tc', 'bc'],
            offset: [0, 4]
          },
          topLeft: {
            points: ['bl', 'tc'],
            offset: [-(horizontalArrowShift + arrowWidth), -4]
          },
          leftTop: {
            points: ['tr', 'cl'],
            offset: [-4, -(verticalArrowShift + arrowWidth)]
          },
          topRight: {
            points: ['br', 'tc'],
            offset: [horizontalArrowShift + arrowWidth, -4]
          },
          rightTop: {
            points: ['tl', 'cr'],
            offset: [4, -(verticalArrowShift + arrowWidth)]
          },
          bottomRight: {
            points: ['tr', 'bc'],
            offset: [horizontalArrowShift + arrowWidth, 4]
          },
          rightBottom: {
            points: ['bl', 'cr'],
            offset: [4, verticalArrowShift + arrowWidth]
          },
          bottomLeft: {
            points: ['tl', 'bc'],
            offset: [-(horizontalArrowShift + arrowWidth), 4]
          },
          leftBottom: {
            points: ['br', 'cl'],
            offset: [-4, verticalArrowShift + arrowWidth]
          }
        };
      }
      return placements;
    };

    return _this;
  }

  Tooltip.prototype.render = function render() {
    return _react2.default.createElement(_rcTooltip2.default, _extends({
      builtinPlacements: this.getPlacements()
    }, this.props));
  };

  return Tooltip;
}(_react2.default.Component);

exports.default = Tooltip;

Tooltip.displayName = 'dh-tooltip';
Tooltip.propTypes = _rcTooltip2.default.propTypes;

Tooltip.defaultProps = Object.assign(_rcTooltip2.default.defaultProps, {
  prefixCls: 'dh-tooltip',
  mouseLeaveDelay: 0
});